<template>
  <div class="relative box-border mktext mb-0">
    <ValidationProvider
      v-slot="{ errors, ariaMsg }"
      :ref="id"
      :rules="rules"
      :immediate="false"
      :vid="vid"
      onkeydown="return event.key != 'Enter';"
    >
      <div
        v-if="!displayonly"
        class="relative border rounded-md outline border-grey-20 focus-within:border-black"
        :class="[
          { 'border-error-20': errors.length > 0 },
          { 'border-error-20': custom_error },
          `mk-text-input-${variant}`,
          { 'mk-input-without-label': inputType == 'withoutlabel' },
        ]"
      >
        <input
          :id="id"
          ref="autocomplete"
          v-model="autocompleteText"
          type="text"
          :placeholder="placeholder"
          autocomplete="off_unhack"
          :disabled="disabled"
          :name="id"
          :aria-describedby="'hlp' + id"
          :class="{
            'origin-bottom-left pl-4':
              (blurStyle && label != null) ||
              (autocompleteText && autocompleteText.length),
          }"
          class="tw-input pt-4 block w-full capitalize p-0 text-base bg-transparent border-none rounded-md h-14 focus:ring-transparent font-primary-font-light"
          @focus="focus()"
          @blur="onBlur()"
          @change="onChange"
        />

        <label
          :id="'lbl' + id"
          :label="label"
          :label-sr-only="labelSrOnly"
          :for="id"
          :class="[{ 'text-error-20': errors.length > 0 }]"
          class="absolute top-0 px-4 py-5 duration-300 text-md origin-0 font-primary-font-light"
          >{{ label }}</label
        >
      </div>
      <div v-else-if="displayonly">
        <label :id="id" :label="label"></label>
        <p>{{ value }}</p>
      </div>

      <p
        v-show="
          errors.length > 0 || (errors.length == 0 && invalidAddressMessage)
        "
        :id="'hlp_err_' + id"
        v-bind="ariaMsg"
        :aria-label="label + ' required'"
        class="mt-1 text-xs text-error-20 md:text-sm"
      >
        {{ errors[0]
        }}<span v-if="errors.length == 0 && invalidAddressMessage">
          {{ invalidAddressMessage }}</span
        >
      </p>
      <p
        v-if="custom_error"
        :id="'hlp_err_' + id"
        v-bind="ariaMsg"
        class="mt-1 text-xs text-error-20 md:text-sm"
      >
        {{ custom_error }}
      </p>

      <p :id="'hlp' + id">{{ helpText }}</p>
    </ValidationProvider>
  </div>
</template>

<script>
import { ValidationProvider } from 'vee-validate'
// Define names needed
const ADDRESS_COMPONENTS = {
  subpremise: 'short_name',
  street_number: 'short_name',
  route: 'long_name',
  locality: 'long_name',
  postal_town: 'long_name',
  administrative_area_level_1: 'short_name',
  administrative_area_level_2: 'long_name',
  country: 'short_name',
  postal_code: 'short_name',
}
const CITIES_TYPE = ['locality', 'administrative_area_level_3', 'postal_town']
const REGIONS_TYPE = [
  'locality',
  'sublocality',
  'postal_code',
  'country',
  'administrative_area_level_1',
  'administrative_area_level_2',
]
/*
      NOTE : CAN ADD MORE FIELDS /FETCH MORE INFO SEE DOCS :
      https://developers.window.google.com/maps/billing/understanding-cost-of-use#basic-data
    */

const AC_DATA_FIELDS = ['address_components', 'geometry']
export default {
  name: 'MKGPlacesAutocomplete',
  components: {
    ValidationProvider,
  },
  inheritAttrs: false,
  props: {
    id: {
      type: String,
      required: true,
    },
    labelSrOnly: {
      type: Boolean,
      default: false,
    },
    helpText: {
      type: String,
      default: null,
    },
    classname: {
      type: String,
      default: '',
    },
    placeholder: {
      type: String,
      default: null,
    },
    label: {
      type: String,
      default: null,
    },
    validation: {
      type: String,
      default: null,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    displayonly: {
      type: Boolean,
      default: false,
    },
    hasError: {
      type: Boolean,
      default: false,
    },
    rules: {
      type: String,
      default: null,
    },
    vid: {
      type: String,
      default: '',
    },
    variant: {
      type: String,
      default: '',
    },
    inputType: {
      type: String,
      default: '',
    },
    types: {
      type: String,
      default: 'address',
    },
    fields: {
      type: Array,
      default() {
        return AC_DATA_FIELDS
      },
    },
    country: {
      type: [String, Array],
      default: null,
    },
    geolocationOptions: {
      type: Object,
      default: null,
    },
    value: {
      type: String,
      default: null,
    },
  },
  data() {
    return {
      blurStyle: false,
      custom_error: null,
      invalid_address_rule: null,
      streetAddress1: null,
      validAddress: '',
      invalidAddressMessage: '',
      /**
       * The Autocomplete object.
       *
       * @type {Autocomplete}
       * @link https://developers.window.google.com/maps/documentation/javascript/reference#Autocomplete
       */
      autocomplete: null,
      /**
       * Autocomplete input text
       * @type {String}
       */
      autocompleteText: '',
      geolocation: {
        /**
         * window.google Geocoder Objet
         * @type {Geocoder}
         * @link https://developers.window.google.com/maps/documentation/javascript/reference#Geocoder
         */
        geocoder: null,
        /**
         * Filled after geolocate result
         * @type {Coordinates}
         * @link https://developer.mozilla.org/en-US/docs/Web/API/Coordinates
         */
        loc: null,
        /**
         * Filled after geolocate result
         * @type {Position}
         * @link https://developer.mozilla.org/en-US/docs/Web/API/Position
         */
        position: null,
      },
    }
  },
  watch: {
    autocompleteText(newVal, oldVal) {
      this.$emit('inputChange', { newVal, oldVal }, this.id)
    },
    country(newVal, oldVal) {
      this.autocomplete.setComponentRestrictions({
        country: this.country === null ? [] : this.country,
      })
    },
    value() {
      this.autocompleteText = this.value
    },
    validAddress() {
      const $parent = this
      setTimeout(function () {
        if ($parent.validAddress === 'invalid') {
          $parent.invalidAddressMessage = 'Please enter a valid street address'
          $parent.$refs.autocomplete.focus()
          $parent.autocompleteText = ''
          $parent.$emit('AC_PLACE_CHANGED', {})
          $parent.$store.dispatch('USER_STORE/SET_VALID_ADDRESS', false)
        } else {
          $parent.$store.dispatch('USER_STORE/SET_VALID_ADDRESS', true)
          $parent.invalidAddressMessage = ''
        }
      }, 600)
    },
  },
  mounted() {
    // this.focusInput()
    const options = {}
    if (this.types) {
      options.types = [this.types]
    }
    if (this.country) {
      options.componentRestrictions = {
        country: this.country,
      }
    }
    this.autocomplete = new window.google.maps.places.Autocomplete(
      document.getElementById(this.id),
      options
    )

    /*
  Must call setFields or else all available place data fields for a place result are returned
    */
    this.autocomplete.setFields(this.fields)
    /*
   When the user selects an address from the drop-down, populate the address fields in the form.
  autocomplete.addListener("place_changed", fillInAddress);
    */
    if (this.value) {
      this.autocompleteText = this.value
    }
    this.autocomplete.addListener('place_changed', this.AC_PLACE_CHANGED)
  },
  methods: {
    focusInput() {
      if (this.value != '' && this.value != null && this.label != null) {
        this.$refs.autocomplete.focus()
      }
    },
    AC_PLACE_CHANGED() {
      this.validAddress = 'valid'
      const place = this.autocomplete.getPlace()
      if (!place.geometry) {
        this.custom_error = 'Please enter a valid address'
        return
      }
      if (place.address_components !== undefined) {
        this.$emit('AC_PLACE_CHANGED', this.formatResult(place), place, this.id)
      }
    },

    onKeyUp(event) {
      this.$emit('keyup', event)
    },
    /**
     * Blur the input
     */
    blur() {
      this.$refs.autocomplete.blur()
    },
    onBlur() {
      this.$emit('blur')
    },
    clear() {
      this.autocompleteText = ''
    },
    focus() {
      this.custom_error = null
      this.$refs.autocomplete.focus()
    },
    update(value) {
      this.autocompleteText = value
    },
    onChange() {
      if(!this.validAddress){
        this.validAddress = 'invalid'
      }
      this.$emit('change', this.autocompleteText)
    },
    updateCoordinates(value) {
      if (!value && !(value.lat || value.lng)) return
      if (!this.geolocation.geocoder)
        this.geolocation.geocoder = new window.google.maps.Geocoder()
      this.geolocation.geocoder.geocode(
        { location: value },
        (results, status) => {
          if (status === 'OK') {
            results = this.filterGeocodeResultTypes(results)
            if (results[0]) {
              this.$emit(
                'AC_PLACE_CHANGED',
                this.formatResult(results[0]),
                results[0],
                this.id
              )
            } else {
              this.$emit('error', 'no result for provided coordinates')
            }
          } else {
            this.$emit('error', 'error getting address from coords')
          }
        }
      )
    },

    /**
     * Format result from Geo window.google APIs
     */
    //   formatResult(place) {
    //   const formattedData = {}
    //   let addressOnePlaceholder = ''
    //   let  availableTypes;
    //   for (let i = 0; i < place.address_components.length; i++) {
    //     for (let j = 0; j < place.address_components[i].types.length; j++) {
    //        if(place.address_components[i].types[j] && ADDRESS_COMPONENTS[place.address_components[i].types[j]]) {
    //          availableTypes = place.address_components[i].types[j];
    //          formattedData[availableTypes] = place.address_components[i][ADDRESS_COMPONENTS[availableTypes]]
    //          break
    //        }
    //     }
    //     // if (ADDRESS_COMPONENTS[availableTypes]) {
    //     //   const val =
    //     //     place.address_components[i][ADDRESS_COMPONENTS[availableTypes]]
    //     //   formattedData[availableTypes] = val
    //     // }
    //   }

    //   const { street_number = '', route = '' } = formattedData
    //   addressOnePlaceholder = `${street_number} ${route}`
    //     ? `${street_number} ${route}`
    //     : `${route}`

    //   if (addressOnePlaceholder.length) {
    //     this.autocompleteText = ' '
    //     this.autocompleteText = addressOnePlaceholder
    //   }
    //   return formattedData
    // },
    formatResult(place) {
      const formattedData = {}
      let addressOnePlaceholder = ''
      for (let i = 0; i < place.address_components.length; i++) {
        const availableTypes = place.address_components[i].types[0]
        if (ADDRESS_COMPONENTS[availableTypes]) {
          const val =
            place.address_components[i][ADDRESS_COMPONENTS[availableTypes]]
          formattedData[availableTypes] = val
        }
      }

      const { street_number = '', route = '' } = formattedData
      addressOnePlaceholder = `${street_number} ${route}`
        ? `${street_number} ${route}`
        : `${route}`

      if (addressOnePlaceholder.length) {
        this.autocompleteText = ' '
        this.autocompleteText = addressOnePlaceholder
      }
      return formattedData
    },
    /**
     * Extract configured types out of raw result as Geocode API does not allow to do it
     * @link https://developers.window.google.com/maps/documentation/javascript/reference#GeocoderResult
     */
    filterGeocodeResultTypes(results) {
      if (!results || !this.types) return results
      const output = []
      let types = [this.types]
      if (types.includes('(cities)')) types = types.concat(CITIES_TYPE)
      if (types.includes('(regions)')) types = types.concat(REGIONS_TYPE)
      for (const r of results) {
        for (const t of r.types) {
          if (types.includes(t)) {
            output.push(r)
            break
          }
        }
      }
      return output
    },
  },
}
</script>

<style lang="postcss">
.mk-text-input-outline {
  @apply border-b border-t-0 border-l-0 border-r-0 rounded-none;
}
.mk-text-input-outline input {
  @apply rounded-none focus:ring-0 pl-0;
}
.mk-text-input-outline label {
  @apply pl-0 text-base;
}
.mk-text-input-outline input:focus-within ~ label,
.mk-text-input-outline input:not(:placeholder-shown) ~ label {
  @apply ml-0 pl-0 leading-4 pt-2;
}
.mk-text-input-outline input:focus-within,
.mk-text-input-outline input:focus {
  @apply origin-bottom-left translate-y-2.5 transform pl-0;
}
.mk-input-without-label input:focus-within,
.mk-input-without-label input:focus {
  @apply transform-none;
}
</style>
